#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAXBUF 16
#define SEC_SZ 6

char secret[MAXBUF] = {'0'};
int checked = 0;

typedef struct {
     char s[MAXBUF];
     int (*f)(char *);
} checker;

int basic_check(char *guess)
{
     char locguess[16];
     printf("Running basic check\n");
     strcpy(locguess, guess);
     checked = 1;
     return strcmp(secret, locguess); // returns 0 on equality
}

int easy_check(char *guess)
{
     char locguess[7];
     printf("Running easy check\n");
     strcpy(locguess, guess);
     checked = 1;
     return !((strlen(locguess) == strlen(secret))
              && (locguess[0] = secret[0])
          );
}

int apply_checker(checker cck)
{
     return cck.f(cck.s);
}

int indirect_check(char *guess)
{
     checker cck;

     printf("Running indirect check\n");
     cck.f = &basic_check;
     strcpy(cck.s, guess);

     return cck.f(cck.s);
}

int f(int n, char* guess)
{
     int (*check)(char *);

     check = &basic_check;
     if (n == 42) check = &easy_check;
     if (n == 0xffffffff) check = &indirect_check;

     return check(guess);
}

void win()
{
     printf("Success!\n");
     return;
}

void fail()
{
     printf("Failure!\n");
     return;
}

int main(int argc, char *argv[])
{
     char x = 0;
     int res;

     if (argc != 3)
     {
          printf("Usage: p num str\n");
          exit(1);
     }

     srand(time(NULL));
     for (int i = 0; i < SEC_SZ; i++)
          secret[i] = (char) (0x41 + rand() % 26);

     printf("My secret is %s. You would be lucky to guess it :-)\n", secret);

     x = atoi(argv[1]);
     res = f(x, argv[2]);

     if (!res && checked) win();
     else fail() ;
     return 0;
}
